const
 VideoSeg : word=$b800;
   ColorX : word=16*Black+DarkGray;          { dialog shadow $07 }
   ColorY : word=16*Black+LightGray;         { hotkey bar numbers $08 }
   Color0 : word=16*Blue+LightCyan;          { identical bytes $1b }
   Color1 : word=16*Blue+Yellow;             { different bytes $1e }
   Color1highlight: word=Yellow;             { cursor foreground for different bytes $0e }
   Color3 : word=16*Blue+LightCyan;          { line address $1b }
   Color4 : word=16*Cyan+Black;              { status bars etc. $30 }
   Color5 : word=16*LightGray+Black;         { LightGray messages $70 }
   Color6 : word=16*Cyan+Black;              { Dialogues $30 }
   Color7 : word=Blue;                       { general background blue $01 }
   Color8 : word=16*Cyan+Yellow;             { cursor for different bytes $3e }
   Color8other: word=16*DarkGray+Yellow;     { inactive cursor for different bytes $8e }
   Color9 : word=16*Cyan+Black;              { cursor for identical bytes $30 }
   Color9other: word=16*DarkGray+LightCyan;  { inactive cursor for identical bytes $8b }
  Color10 : word=16*LightGray+Black;         { scroll bars $71 }
  Color11 : word=16*LightGray+Red;           { byte edited $74 }

type
  symb=record
    chr : char;
    atr : byte;
    end;

  row=0..49;
  col=0..79;

  video=array[1..8000] of byte;
  pvideo=^video;

  screen=record
            x : col;
            y : row;
     VideoMem : Video;
   end;

  scrtype=array[row,col] of symb;
  pscrtype=^scrtype;

var
        scr : pscrtype;                     {absolute $b800:0;}
ScreenArray : array[1..3] of screen;
 RealScreen : pvideo;
  ScrHeight : Byte;
   ScrWidth : Byte;
OrigScrHeight: Byte;

procedure SaveScr(n:integer);
begin
  ScreenArray[n].VideoMem:=RealScreen^;
  ScreenArray[n].x:=WhereX-1;
  ScreenArray[n].y:=WhereY-1;
end;

procedure RestoreScr(n:integer);
begin
  HidePtr;
  RealScreen^:=ScreenArray[n].VideoMem;
  GotoXY(ScreenArray[n].x+1,ScreenArray[n].y+1);
  ShowPtr;
end;

procedure VideoInt; assembler;
asm
        PUSH    BP
        PUSH    ES
        INT     10H
        POP     ES
        POP     BP
end;

procedure SetScreenSize; assembler;
asm
        MOV     AH,0FH
        CALL    VideoInt
        MOV     DH,AH
        XOR     AH,AH
        PUSH    AX
        MOV     AX,1130H
        XOR     BH,BH
        XOR     DL,DL
        MOV     CL,DH
        PUSH    CX
        CALL    VideoInt
        POP     CX
        MOV     DH,CL
        POP     AX
        OR      DL,DL
        JNE     @@1
        MOV     DL,24
@@1:    INC     DL
        MOV     ScrWidth,DH
        MOV     ScrHeight,DL
end;

procedure SetBlinkBright(Bright: Boolean);
begin
  Bright := not Bright;
  if VideoSeg =$b800 then
  begin
    asm
      mov ax, $1003;
      mov bl, Bright;
      call VideoInt;
    end;
  end;
end;

procedure CheckVideo;
begin
  SetScreenSize;
  if (MemW[0:$0410] and $30)=$30 then
    begin                               {Hercules}
      VideoSeg:=$b000;
      ColorX:=$00;                { dialog shadow: none }
      ColorY:=$07;                { hotkey bar numbers: gray on black }
      Color0:=$07;                { identical bytes: gray on black }
      Color1:=$0F;                { different bytes: white on black }
      Color1highlight:=$0F;       { cursor foreground for different bytes: white foreground }
      Color3:=$07;                { line address: gray on black }
      Color4:=$70;                { status bars etc.: black on gray }
      Color5:=$70;                { LightGray messages: black on gray }
      Color6:=$07;                { Dialogues: black on gray }
      Color7:=$70;                { general background blue: black on gray }
      Color8:=$78;                { cursor for different bytes: dark gray (or black) on gray }
      Color8other:=$09;           { inactive cursor for different bytes: underlined white on black }
      Color9:=$70;                { cursor for identical bytes: black on gray }
      Color9other:=$01;           { inactive cursor for identical bytes: underlined gray on black }
      Color10:=$70;               { scroll bars: black on gray }
      Color11:=$78;               { byte edited: dark gray (or black) on gray }
    end;
  scr:=ptr(VideoSeg,0);
  RealScreen:=ptr(VideoSeg,0);
  SetBlinkBright(true);
end;
